var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from2, except, desc) => {
  if (from2 && typeof from2 === "object" || typeof from2 === "function") {
    for (let key of __getOwnPropNames(from2))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from2[key], enumerable: !(desc = __getOwnPropDesc(from2, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  combine: () => combine,
  create: () => create,
  createProvider: () => createProvider,
  defaultProviderOptions: () => defaultProviderOptions,
  from: () => from,
  value: () => value
});
module.exports = __toCommonJS(src_exports);

// src/instrument.ts
var import_util = __toESM(require("util"));
var import_debug = __toESM(require("debug"));
function debug(name, fn) {
  const _debugger = (0, import_debug.default)(`submodule.runtime.${name}`);
  return function() {
    const that = this;
    const args = arguments;
    _debugger("calling function %s, with %O", name, arguments);
    const result = fn.apply(that, args);
    if (result === void 0) {
      _debugger("completed function call %s", name);
      return;
    } else if (import_util.default.types.isPromise(result)) {
      return result.then((next) => {
        _debugger("completed function call %s, with %O", name, next);
        return next;
      }).catch((e) => {
        _debugger("caught an exception function call %s, with %O", name, e);
        throw e;
      });
    } else {
      return result;
    }
  };
}
function instrument(input, instrumentFn, maxLevel = 1, currentLevel = 0) {
  if (input === null || input === void 0)
    return input;
  if (currentLevel > maxLevel)
    return input;
  if (
    // there can be more
    typeof input !== "object" || Array.isArray(input) || // built-in objects like date, bytearray etc
    import_util.default.types.isDate(input)
  ) {
    return input;
  }
  Object.keys(input).forEach((key) => {
    const instance = input[key];
    if (typeof instance === "function") {
      input[key] = instrumentFn(key, instance);
    } else {
      input[key] = instrument(input[key], instrumentFn, maxLevel, currentLevel + 1);
    }
  });
  return input;
}

// src/index.ts
var defaultProviderOptions = {
  mode: "singleton"
};
function create(provider, dependent, options = defaultProviderOptions) {
  const opts = { ...defaultProviderOptions, ...options };
  let cached = void 0;
  let dependentRef = dependent;
  async function load() {
    const actualized = dependentRef ? await dependentRef.get() : void 0;
    const provide = await provider(actualized);
    return { provide };
  }
  async function init() {
    if (opts.mode === "prototype") {
      cached = load();
    } else {
      if (cached === void 0) {
        cached = load();
      }
    }
    return cached;
  }
  async function execute(provider2) {
    const { provide } = await init();
    return provider2(provide);
  }
  async function get() {
    const { provide } = await init();
    return provide;
  }
  function prepare(provider2) {
    return async function(input) {
      const { provide } = await init();
      return provider2(provide, input);
    };
  }
  const _inject = async (executor2) => {
    dependentRef = executor2;
  };
  const executor = { execute, get, prepare, _inject };
  instrument(executor, debug);
  if (opts.instrument) {
    instrument(executor, opts.instrument);
  }
  return executor;
}
var createProvider = (provider) => provider;
var value = (value2) => create(() => value2);
var from = (executor) => {
  return {
    provide: (provider, opts = defaultProviderOptions) => create(provider, executor, opts),
    execute: async (executable) => executor.execute(executable),
    prepare: (provider) => executor.prepare(provider)
  };
};
var combine = function(layout) {
  return create(async () => {
    const result = {};
    for (const [key, value2] of Object.entries(layout)) {
      result[key] = await value2.get();
    }
    return result;
  });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  combine,
  create,
  createProvider,
  defaultProviderOptions,
  from,
  value
});
//# sourceMappingURL=index.js.map